PStringSet Class Reference

This is a set collection class of `PString` objects. More...

`#include <pstring.h>`

Inheritance diagram for PStringSet:

## Public Member Functions

Construction
| PStringSet (PINDEX count, char const *const *strarr, PBoolean caseless=false)
| Create a PStringArray from the array of C strings. More...
| PStringSet (const PString &str)
| Create a PStringSet containing the single string. More...
| PStringSet (const PStringArray &strArray)
| Create a PStringSet containing the strings. More...
| PStringSet (const PStringList &strList)
| Create a PStringSet containing the strings. More...
Overrides from class PObject
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
Operations
void | Include (const PString &key)
| Include the spcified string value into the set. More...
PStringSet & | operator+= (const PString &key)
| Include the spcified string value into the set. More...
void | Exclude (const PString &key)
| Exclude the spcified string value from the set. More...
PStringSet & | operator-= (const PString &key)
| Exclude the spcified string value from the set. More...
Public Member Functions inherited from PSet< T >
| PSet (PBoolean initialDeleteObjects=false)
| Create a new, empty, dictionary. More...
virtual PObject * | Clone () const
| Make a complete duplicate of the set. More...
void | Include (const T *obj)
| Include the specified object into the set. More...
PSet & | operator+= (const T &obj)
| Include the specified objects value into the set. More...
void | Exclude (const T *obj)
| Remove the object from the set. More...
PSet & | operator-= (const T &obj)
| Remove the objects value from the set. More...
PBoolean | Contains (const T &key) const
| Determine if the value of the object is contained in the set. More...
PBoolean | operator[] (const T &key) const
| Determine if the value of the object is contained in the set. More...
virtual const T & | GetKeyAt (PINDEX index) const
| Get the key in the set at the ordinal index position. More...
Public Member Functions inherited from PAbstractSet
PINLINE | PAbstractSet ()
| Create a new, empty, set. More...
virtual PINDEX | Append (PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Add a new object to the collection. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PObject * | GetAt (PINDEX index) const
| This function is the same as PHashTable::AbstractGetKeyAt(). More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Add a new object to the collection. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
bool | Union (const PAbstractSet &set)
| Calculate union of sets. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...

## Additional Inherited Members

Public Types inherited from PHashTable
typedef PHashTableElement | Element
typedef PHashTableInfo | Table
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PAbstractSet
static bool | Intersection (const PAbstractSet &set1, const PAbstractSet &set2, PAbstractSet *intersection=NULL)
| Calculate intersection of sets. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Member Functions inherited from PSet< T >
| PSet (int dummy, const PSet *c)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Detailed Description

This is a set collection class of `PString` objects.

It has all the usual functions for a collection, with the object types set to `PString` pointers.

In addition some addition functions are added that take a const `PString` reference instead of a pointer as most standard collection functions do. This is more convenient for when string expressions are used as parameters to function in the collection.

Unlike the normal sets, this will delete the PStrings removed from it. This complements the automatic creation of new PString objects when literals or expressions are used.

See the `PAbstractSet` and `PSet` classes and `PDECLARE_SET` macro for more information.

## Constructor & Destructor Documentation

PStringSet::PStringSet | ( | PINDEX | count,
|  | char const *const * | strarr,
|  | PBoolean | caseless = `false`
| ) |  |

Create a PStringArray from the array of C strings.

Parameters

  count | Count of strings in array
  strarr | Array of C strings
  caseless | New strings are to be PCaselessStrings

PStringSet::PStringSet | ( | const PString & | str | ) |

Create a PStringSet containing the single string.

Parameters

  str | Single string to convert to a set of one.

PStringSet::PStringSet | ( | const PStringArray & | strArray | ) |

Create a PStringSet containing the strings.

Parameters

  strArray | String to convert to a set.

PStringSet::PStringSet | ( | const PStringList & | strList | ) |

Create a PStringSet containing the strings.

Parameters

  strList | String to convert to a set.

## Member Function Documentation

void PStringSet::Exclude | ( | const PString & | key | ) |

Exclude the spcified string value from the set.

Parameters

  key | String value to remove from set.

void PStringSet::Include | ( | const PString & | key | ) |

Include the spcified string value into the set.

Parameters

  key | String value to add to set.

PStringSet& PStringSet::operator+= | ( | const PString & | key | ) |

Include the spcified string value into the set.

Parameters

  key | String value to add to set.

PStringSet& PStringSet::operator-= | ( | const PString & | key | ) |

Exclude the spcified string value from the set.

Parameters

  key | String value to remove from set.

virtual void PStringSet::ReadFrom | ( | istream & | strm | ) |

virtual

Input the contents of the object from the stream.

This is primarily used by the standard `operator>>` function.

The default behaviour reads '\n' separated strings until `!strm.good()`.

Parameters

  strm | Stream to read the objects contents from.

Reimplemented from PObject.

The documentation for this class was generated from the following file:

- pstring.h